<template>
  <div>
    <!-- Name field -->
    <b-field
      :type="{ 'is-danger': $v.name.$error }"
      :message="{
        'Name is required': $v.name.$error && !$v.name.required,
        'Name should have at least 3 characters': $v.name.$error && !$v.name.minLength
      }"
      label="Name"
    >
      <b-input
        v-model="$v.name.$model"
        size="is-medium"
      />
    </b-field>

    <!-- Email field -->
    <b-field
      :type="{ 'is-danger': $v.email.$error }"
      :message="{
        'Email is required': $v.email.$error && !$v.email.required,
        'Email is not in correct format': $v.email.$error && !$v.email.email
      }"
      label="Email"
    >
      <b-input
        v-model="$v.email.$model"
        size="is-medium"
      />
    </b-field>

    <!-- Password field -->
    <b-field
      :type="{ 'is-danger': $v.password.$error }"
      :message="{
        'Password is required': $v.password.$error && !$v.password.required,
        'Password should have at least 8 characters': $v.password.$error && !$v.password.minLength
      }"
      label="Password"
    >
      <b-input
        v-model="$v.password.$model"
        type="password"
        size="is-medium"
        password-reveal
      />
    </b-field>

    <!-- Submit button -->
    <b-field>
      <b-button
        @click="doSignup"
        :expanded="true"
        :loading="processingSignup"
        :disabled="processingSignup"
        size="is-medium"
        type="is-primary"
      >
        Get started
      </b-button>
    </b-field>
  </div>
</template>

<script>
import { required, email, minLength } from 'vuelidate/lib/validators'

export default {
  props: {
    processingSignup: {
      type: Boolean,
      default: false
    },
    onValid: {
      type: Function,
      required: true
    }
  },

  data () {
    return {
      name: '',
      email: '',
      password: ''
    }
  },

  validations: {
    name: { required, minLength: minLength(3) },
    email: { required, email },
    password: { required, minLength: minLength(8) }
  },

  methods: {
    doSignup () {
      this.$v.$touch()
      if (!this.$v.$invalid) {
        this.onValid({
          'name': this.name,
          'email': this.email,
          'password': this.password
        })
      }
    }
  }
}
</script>
